refactor scm_i_print_symbol_name
[bpt/guile.git] / maint.mk
CommitLineData
c84bdaf6
LC
1# -*-Makefile-*-
2# This Makefile fragment tries to be general-purpose enough to be
3# used by many projects via the gnulib maintainer-makefile module.
4
49114fd4 5## Copyright (C) 2001-2011 Free Software Foundation, Inc.
c84bdaf6
LC
6##
7## This program is free software: you can redistribute it and/or modify
8## it under the terms of the GNU General Public License as published by
9## the Free Software Foundation, either version 3 of the License, or
10## (at your option) any later version.
11##
12## This program is distributed in the hope that it will be useful,
13## but WITHOUT ANY WARRANTY; without even the implied warranty of
14## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15## GNU General Public License for more details.
16##
17## You should have received a copy of the GNU General Public License
18## along with this program. If not, see <http://www.gnu.org/licenses/>.
19
20# This is reported not to work with make-3.79.1
21# ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22ME := maint.mk
23
24# Override this in cfg.mk if you use a non-standard build-aux directory.
25build_aux ?= $(srcdir)/build-aux
26
27# Do not save the original name or timestamp in the .tar.gz file.
28# Use --rsyncable if available.
29gzip_rsyncable := \
a927b6c1
LC
30 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
31 && printf %s --rsyncable)
c84bdaf6
LC
32GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
33
c84bdaf6
LC
34GIT = git
35VC = $(GIT)
36VC-tag = git tag -s -m '$(VERSION)' -u '$(gpg_key_ID)'
37
38VC_LIST = $(build_aux)/vc-list-files -C $(srcdir)
39
61cd9dc9
LC
40# You can override this variable in cfg.mk to set your own regexp
41# matching files to ignore.
42VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
43
44# This is to preprocess robustly the output of $(VC_LIST), so that even
45# when $(srcdir) is a pathological name like "....", the leading sed command
46# removes only the intended prefix.
47_dot_escaped_srcdir = $(subst .,\.,$(srcdir))
48
49# Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
50# when $(srcdir) is not ".".
51ifeq ($(srcdir),.)
52_prepend_srcdir_prefix =
53else
54_prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
55endif
56
57# In order to be able to consistently filter "."-relative names,
58# (i.e., with no $(srcdir) prefix), this definition is careful to
59# remove any $(srcdir) prefix, and to restore what it removes.
c84bdaf6 60VC_LIST_EXCEPT = \
61cd9dc9
LC
61 $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
62 | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
63 else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
64 | grep -Ev -e '$(VC_LIST_ALWAYS_EXCLUDE_REGEX)' \
65 $(_prepend_srcdir_prefix)
c84bdaf6
LC
66
67ifeq ($(origin prev_version_file), undefined)
68 prev_version_file = $(srcdir)/.prev-version
69endif
70
71PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
72VERSION_REGEXP = $(subst .,\.,$(VERSION))
73PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
74
75ifeq ($(VC),$(GIT))
76this-vc-tag = v$(VERSION)
77this-vc-tag-regexp = v$(VERSION_REGEXP)
78else
79tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
80tag-this-version = $(subst .,_,$(VERSION))
81this-vc-tag = $(tag-package)-$(tag-this-version)
82this-vc-tag-regexp = $(this-vc-tag)
83endif
84my_distdir = $(PACKAGE)-$(VERSION)
85
86# Old releases are stored here.
87release_archive_dir ?= ../release
88
414e4441
LC
89# Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
90# Use alpha.gnu.org for alpha and beta releases.
91# Use ftp.gnu.org for stable releases.
92gnu_ftp_host-alpha = alpha.gnu.org
93gnu_ftp_host-beta = alpha.gnu.org
94gnu_ftp_host-stable = ftp.gnu.org
95gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
96
97ifeq ($(gnu_rel_host),ftp.gnu.org)
98url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
99else
100url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
101endif
102
1cd4fffc
LC
103# Override this in cfg.mk if you are using a different format in your
104# NEWS file.
105today = $(shell date +%Y-%m-%d)
9157d901
LC
106
107# Select which lines of NEWS are searched for $(news-check-regexp).
108# This is a sed line number spec. The default says that we search
109# lines 1..10 of NEWS for $(news-check-regexp).
110# If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
111news-check-lines-spec ?= 1,10
1cd4fffc
LC
112news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
113
c84bdaf6
LC
114# Prevent programs like 'sort' from considering distinct strings to be equal.
115# Doing it here saves us from having to set LC_ALL elsewhere in this file.
116export LC_ALL = C
117
118## --------------- ##
119## Sanity checks. ##
120## --------------- ##
121
122_cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
123
124# Collect the names of rules starting with `sc_'.
125syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
126 $(srcdir)/$(ME) $(_cfg_mk)))
127.PHONY: $(syntax-check-rules)
128
dd36ce77
MW
129ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
130local-checks-available += $(syntax-check-rules)
131else
132local-checks-available += no-vc-detected
133no-vc-detected:
134 @echo "No version control files detected; skipping syntax check"
135endif
c84bdaf6
LC
136.PHONY: $(local-checks-available)
137
138# Arrange to print the name of each syntax-checking rule just before running it.
139$(syntax-check-rules): %: %.m
dde9c5a4
LC
140sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
141.PHONY: $(sc_m_rules_)
142$(sc_m_rules_):
c84bdaf6 143 @echo $(patsubst sc_%.m, %, $@)
a927b6c1
LC
144 @date +%s.%N > .sc-start-$(basename $@)
145
146# Compute and print the elapsed time for each syntax-check rule.
147sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
148.PHONY: $(sc_z_rules_)
149$(sc_z_rules_): %.z: %
150 @end=$$(date +%s.%N); \
151 start=$$(cat .sc-start-$*); \
152 rm -f .sc-start-$*; \
153 awk -v s=$$start -v e=$$end \
154 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
155
156# The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
157# that computes and prints elapsed time.
158local-check := \
159 $(patsubst sc_%, sc_%.z, \
160 $(filter-out $(local-checks-to-skip), $(local-checks-available)))
c84bdaf6
LC
161
162syntax-check: $(local-check)
a927b6c1
LC
163
164# _sc_search_regexp
165#
166# This macro searches for a given construct in the selected files and
167# then takes some action.
168#
169# Parameters (shell variables):
170#
171# prohibit | require
172#
173# Regular expression (ERE) denoting either a forbidden construct
174# or a required construct. Those arguments are exclusive.
175#
176# in_vc_files | in_files
177#
178# grep-E-style regexp denoting the files to check. If no files
179# are specified the default are all the files that are under
180# version control.
181#
182# containing | non_containing
183#
184# Select the files (non) containing strings matching this regexp.
185# If both arguments are specified then CONTAINING takes
186# precedence.
187#
188# with_grep_options
189#
190# Extra options for grep.
191#
192# ignore_case
193#
194# Ignore case.
195#
196# halt
197#
198# Message to display before to halting execution.
199
200# By default, _sc_search_regexp does not ignore case.
c84bdaf6 201export ignore_case =
a927b6c1 202_ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
c84bdaf6 203
a927b6c1
LC
204define _sc_say_and_exit
205 dummy=; : so we do not need a semicolon before each use; \
206 { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
207endef
208
209# _sc_search_regexp used to be named _prohibit_regexp. However,
210# upgrading to the new definition and leaving the old name undefined
211# would usually convert each custom rule using $(_prohibit_regexp)
212# (usually defined in cfg.mk) into a no-op. This definition ensures
213# that people know right away if they're still using the old name.
214# FIXME: remove in 2012.
215_prohibit_regexp = \
216 $(error '*** you need to s/_prohibit_regexp/_sc_search_regexp/, and adapt')
217
218define _sc_search_regexp
219 dummy=; : so we do not need a semicolon before each use; \
220 \
221 : Check arguments; \
222 test -n "$$prohibit" && test -n "$$require" \
223 && { msg='Cannot specify both prohibit and require' \
224 $(_sc_say_and_exit) } || :; \
225 test -z "$$prohibit" && test -z "$$require" \
226 && { msg='Should specify either prohibit or require' \
227 $(_sc_say_and_exit) } || :; \
228 test -n "$$in_vc_files" && test -n "$$in_files" \
229 && { msg='Cannot specify both in_vc_files and in_files' \
230 $(_sc_say_and_exit) } || :; \
231 test "x$$halt" != x \
232 || { msg='halt not defined' $(_sc_say_and_exit) }; \
233 \
234 : Filter by file name; \
235 if test -n "$$in_files"; then \
236 files=$$(find $(srcdir) | grep -E "$$in_files"); \
237 else \
238 files=$$($(VC_LIST_EXCEPT)); \
239 if test -n "$$in_vc_files"; then \
240 files=$$(echo "$$files" | grep -E "$$in_vc_files"); \
241 fi; \
242 fi; \
243 \
244 : Filter by content; \
245 test -n "$$files" && test -n "$$containing" \
246 && { files=$$(grep -l "$$containing" $$files); } || :; \
247 test -n "$$files" && test -n "$$non_containing" \
248 && { files=$$(grep -vl "$$non_containing" $$files); } || :; \
249 \
250 : Check for the construct; \
251 if test -n "$$files"; then \
252 if test -n "$$prohibit"; then \
253 grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
254 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
255 else \
256 grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
257 | grep . \
258 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
259 fi \
260 else :; \
261 fi || :;
c84bdaf6
LC
262endef
263
264sc_avoid_if_before_free:
265 @$(build_aux)/useless-if-before-free \
266 $(useless_free_options) \
267 $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) && \
268 { echo '$(ME): found useless "if" before "free" above' 1>&2; \
269 exit 1; } || :
270
271sc_cast_of_argument_to_free:
a927b6c1
LC
272 @prohibit='\<free *\( *\(' halt='don'\''t cast free argument' \
273 $(_sc_search_regexp)
c84bdaf6
LC
274
275sc_cast_of_x_alloc_return_value:
a927b6c1
LC
276 @prohibit='\*\) *x(m|c|re)alloc\>' \
277 halt='don'\''t cast x*alloc return value' \
278 $(_sc_search_regexp)
c84bdaf6
LC
279
280sc_cast_of_alloca_return_value:
a927b6c1
LC
281 @prohibit='\*\) *alloca\>' \
282 halt='don'\''t cast alloca return value' \
283 $(_sc_search_regexp)
c84bdaf6
LC
284
285sc_space_tab:
a927b6c1
LC
286 @prohibit='[ ] ' \
287 halt='found SPACE-TAB sequence; remove the SPACE' \
288 $(_sc_search_regexp)
c84bdaf6
LC
289
290# Don't use *scanf or the old ato* functions in `real' code.
291# They provide no error checking mechanism.
292# Instead, use strto* functions.
293sc_prohibit_atoi_atof:
a927b6c1
LC
294 @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\(' \
295 halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
296 $(_sc_search_regexp)
c84bdaf6
LC
297
298# Use STREQ rather than comparing strcmp == 0, or != 0.
299sc_prohibit_strcmp:
49114fd4 300 @grep -nE '! *str''cmp *\(|\<str''cmp *\(.+\) *[!=]=' \
c84bdaf6 301 $$($(VC_LIST_EXCEPT)) \
49114fd4
LC
302 | grep -vE ':# *define STRN?EQ\(' && \
303 { echo '$(ME): replace str''cmp calls above with STREQ/STRNEQ' \
c84bdaf6
LC
304 1>&2; exit 1; } || :
305
306# Pass EXIT_*, not number, to usage, exit, and error (when exiting)
414e4441
LC
307# Convert all uses automatically, via these two commands:
308# git grep -l '\<exit *(1)' \
309# | grep -vEf .x-sc_prohibit_magic_number_exit \
310# | xargs --no-run-if-empty \
311# perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
312# git grep -l '\<exit *(0)' \
313# | grep -vEf .x-sc_prohibit_magic_number_exit \
314# | xargs --no-run-if-empty \
315# perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
c84bdaf6 316sc_prohibit_magic_number_exit:
a927b6c1
LC
317 @prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,' \
318 halt='use EXIT_* values rather than magic number' \
319 $(_sc_search_regexp)
c84bdaf6
LC
320
321# Using EXIT_SUCCESS as the first argument to error is misleading,
322# since when that parameter is 0, error does not exit. Use `0' instead.
323sc_error_exit_success:
a927b6c1
LC
324 @prohibit='error *\(EXIT_SUCCESS,' \
325 in_vc_files='\.[chly]$$' \
326 halt='found error (EXIT_SUCCESS' \
327 $(_sc_search_regexp)
c84bdaf6
LC
328
329# `FATAL:' should be fully upper-cased in error messages
330# `WARNING:' should be fully upper-cased, or fully lower-cased
331sc_error_message_warn_fatal:
a927b6c1 332 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
333 | grep -E '"Warning|"Fatal|"fatal' && \
334 { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
335 exit 1; } || :
336
337# Error messages should not start with a capital letter
338sc_error_message_uppercase:
a927b6c1 339 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
340 | grep -E '"[A-Z]' \
341 | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
342 { echo '$(ME): found capitalized error message' 1>&2; \
343 exit 1; } || :
344
345# Error messages should not end with a period
346sc_error_message_period:
a927b6c1 347 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
348 | grep -E '[^."]\."' && \
349 { echo '$(ME): found error message ending in period' 1>&2; \
350 exit 1; } || :
351
352sc_file_system:
a927b6c1
LC
353 @prohibit=file''system \
354 ignore_case=1 \
355 halt='found use of "file''system"; spell it "file system"' \
356 $(_sc_search_regexp)
c84bdaf6
LC
357
358# Don't use cpp tests of this symbol. All code assumes config.h is included.
359sc_prohibit_have_config_h:
a927b6c1
LC
360 @prohibit='^# *if.*HAVE''_CONFIG_H' \
361 halt='found use of HAVE''_CONFIG_H; remove' \
362 $(_sc_search_regexp)
c84bdaf6
LC
363
364# Nearly all .c files must include <config.h>. However, we also permit this
365# via inclusion of a package-specific header, if cfg.mk specified one.
366# config_h_header must be suitable for grep -E.
367config_h_header ?= <config\.h>
368sc_require_config_h:
a927b6c1
LC
369 @require='^# *include $(config_h_header)' \
370 in_vc_files='\.c$$' \
371 halt='the above files do not include <config.h>' \
372 $(_sc_search_regexp)
c84bdaf6
LC
373
374# You must include <config.h> before including any other header file.
375# This can possibly be via a package-specific header, if given by cfg.mk.
376sc_require_config_h_first:
377 @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
378 fail=0; \
379 for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do \
380 grep '^# *include\>' $$i | sed 1q \
381 | grep -E '^# *include $(config_h_header)' > /dev/null \
382 || { echo $$i; fail=1; }; \
383 done; \
384 test $$fail = 1 && \
385 { echo '$(ME): the above files include some other header' \
386 'before <config.h>' 1>&2; exit 1; } || :; \
387 else :; \
388 fi
389
390sc_prohibit_HAVE_MBRTOWC:
a927b6c1
LC
391 @prohibit='\bHAVE_MBRTOWC\b' \
392 halt="do not use $$prohibit; it is always defined" \
393 $(_sc_search_regexp)
c84bdaf6
LC
394
395# To use this "command" macro, you must first define two shell variables:
396# h: the header, enclosed in <> or ""
397# re: a regular expression that matches IFF something provided by $h is used.
a927b6c1 398define _sc_header_without_use
c84bdaf6
LC
399 dummy=; : so we do not need a semicolon before each use; \
400 h_esc=`echo "$$h"|sed 's/\./\\\\./g'`; \
401 if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
402 files=$$(grep -l '^# *include '"$$h_esc" \
403 $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
404 grep -LE "$$re" $$files | grep . && \
405 { echo "$(ME): the above files include $$h but don't use it" \
406 1>&2; exit 1; } || :; \
407 else :; \
408 fi
409endef
410
411# Prohibit the inclusion of assert.h without an actual use of assert.
412sc_prohibit_assert_without_use:
a927b6c1 413 @h='<assert.h>' re='\<assert *\(' $(_sc_header_without_use)
c84bdaf6
LC
414
415# Prohibit the inclusion of close-stream.h without an actual use.
416sc_prohibit_close_stream_without_use:
a927b6c1 417 @h='"close-stream.h"' re='\<close_stream *\(' $(_sc_header_without_use)
c84bdaf6
LC
418
419# Prohibit the inclusion of getopt.h without an actual use.
420sc_prohibit_getopt_without_use:
a927b6c1 421 @h='<getopt.h>' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
422
423# Don't include quotearg.h unless you use one of its functions.
424sc_prohibit_quotearg_without_use:
a927b6c1 425 @h='"quotearg.h"' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
426
427# Don't include quote.h unless you use one of its functions.
428sc_prohibit_quote_without_use:
a927b6c1 429 @h='"quote.h"' re='\<quote(_n)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
430
431# Don't include this header unless you use one of its functions.
432sc_prohibit_long_options_without_use:
433 @h='"long-options.h"' re='\<parse_long_options *\(' \
a927b6c1 434 $(_sc_header_without_use)
c84bdaf6
LC
435
436# Don't include this header unless you use one of its functions.
437sc_prohibit_inttostr_without_use:
438 @h='"inttostr.h"' re='\<(off|[iu]max|uint)tostr *\(' \
a927b6c1 439 $(_sc_header_without_use)
c84bdaf6 440
61cd9dc9
LC
441# Don't include this header unless you use one of its functions.
442sc_prohibit_ignore_value_without_use:
443 @h='"ignore-value.h"' re='\<ignore_(value|ptr) *\(' \
a927b6c1 444 $(_sc_header_without_use)
61cd9dc9 445
c84bdaf6
LC
446# Don't include this header unless you use one of its functions.
447sc_prohibit_error_without_use:
448 @h='"error.h"' \
449 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
a927b6c1 450 $(_sc_header_without_use)
c84bdaf6
LC
451
452# Don't include xalloc.h unless you use one of its functions.
453# Consider these symbols:
454# perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
a927b6c1 455# perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
c84bdaf6
LC
456# Divide into two sets on case, and filter each through this:
457# | sort | perl -MRegexp::Assemble -le \
458# 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
459# Note this was produced by the above:
61cd9dc9
LC
460# _xa1 = \
461#x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
462# But we can do better, in at least two ways:
463# 1) take advantage of two "dup"-suffixed strings:
464# x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
465# 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
466# "char|[cmz]"
467# x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
468_xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
c84bdaf6
LC
469_xa2 = X([CZ]|N?M)ALLOC
470sc_prohibit_xalloc_without_use:
471 @h='"xalloc.h"' \
472 re='\<($(_xa1)|$(_xa2)) *\('\
a927b6c1 473 $(_sc_header_without_use)
c84bdaf6 474
dde9c5a4 475# Extract function names:
a927b6c1 476# perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
dde9c5a4
LC
477_hash_re = \
478clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
479_hash_fn = \<($(_hash_re)) *\(
480_hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
481sc_prohibit_hash_without_use:
482 @h='"hash.h"' \
483 re='$(_hash_fn)|$(_hash_struct)'\
a927b6c1 484 $(_sc_header_without_use)
dde9c5a4
LC
485
486sc_prohibit_hash_pjw_without_use:
487 @h='"hash-pjw.h"' \
488 re='\<hash_pjw *\(' \
a927b6c1 489 $(_sc_header_without_use)
dde9c5a4 490
c84bdaf6
LC
491sc_prohibit_safe_read_without_use:
492 @h='"safe-read.h"' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
a927b6c1 493 $(_sc_header_without_use)
c84bdaf6
LC
494
495sc_prohibit_argmatch_without_use:
496 @h='"argmatch.h"' \
497 re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
a927b6c1 498 $(_sc_header_without_use)
c84bdaf6
LC
499
500sc_prohibit_canonicalize_without_use:
501 @h='"canonicalize.h"' \
502 re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \
a927b6c1 503 $(_sc_header_without_use)
c84bdaf6
LC
504
505sc_prohibit_root_dev_ino_without_use:
506 @h='"root-dev-ino.h"' \
507 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
a927b6c1 508 $(_sc_header_without_use)
c84bdaf6
LC
509
510sc_prohibit_openat_without_use:
511 @h='"openat.h"' \
512 re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
a927b6c1 513 $(_sc_header_without_use)
c84bdaf6
LC
514
515# Prohibit the inclusion of c-ctype.h without an actual use.
516ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
517|isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
518sc_prohibit_c_ctype_without_use:
a927b6c1
LC
519 @h='[<"]c-ctype.h[">]' re='\<c_($(ctype_re)) *\(' \
520 $(_sc_header_without_use)
c84bdaf6
LC
521
522_empty =
523_sp = $(_empty) $(_empty)
524# The following list was generated by running:
525# man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
526# | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
527_sig_functions = \
528 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
529 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
530 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
531 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
532_sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
533# The following were extracted from "man signal.h" manually.
534_sig_types_and_consts = \
535 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
536 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
537 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
538 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
539 sigstack sigval stack_t ucontext_t
540# generated via this:
541# perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
542_sig_names = \
543 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
544 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
545 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
546 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
547 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
548 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
549 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
550 SIGXCPU SIGXFSZ
551_sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
552
553# Prohibit the inclusion of signal.h without an actual use.
554sc_prohibit_signal_without_use:
555 @h='<signal.h>' \
556 re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
a927b6c1
LC
557 $(_sc_header_without_use)
558
559# Prohibit the inclusion of strings.h without a sensible use.
560# Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
561sc_prohibit_strings_without_use:
562 @h='<strings.h>' \
563 re='\<(strn?casecmp|ffs(ll)?)\>' \
564 $(_sc_header_without_use)
565
566# Get the list of symbol names with this:
567# perl -lne '/^# *define (\w+)\(/ and print $1' lib/intprops.h|grep -v '^s'|fmt
568_intprops_names = \
569 TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT \
570 TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM \
571 INT_STRLEN_BOUND INT_BUFSIZE_BOUND
572_intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
573# Prohibit the inclusion of intprops.h without an actual use.
574sc_prohibit_intprops_without_use:
575 @h='"intprops.h"' \
576 re='\<($(_intprops_syms_re)) *\(' \
577 $(_sc_header_without_use)
c84bdaf6 578
49114fd4
LC
579_stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
580# Prohibit the inclusion of stddef.h without an actual use.
581sc_prohibit_stddef_without_use:
582 @h='<stddef.h>' \
583 re='\<($(_stddef_syms_re)) *\(' \
584 $(_sc_header_without_use)
585
c84bdaf6 586sc_obsolete_symbols:
a927b6c1
LC
587 @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
588 halt='do not use HAVE''_FCNTL_H or O'_NDELAY \
589 $(_sc_search_regexp)
c84bdaf6
LC
590
591# FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
592
593# Each nonempty ChangeLog line must start with a year number, or a TAB.
594sc_changelog:
a927b6c1
LC
595 @prohibit='^[^12 ]' \
596 in_vc_files='^ChangeLog$$' \
597 halt='found unexpected prefix in a ChangeLog' \
598 $(_sc_search_regexp)
c84bdaf6
LC
599
600# Ensure that each .c file containing a "main" function also
601# calls set_program_name.
602sc_program_name:
a927b6c1
LC
603 @require='set_program_name *\(m?argv\[0\]\);' \
604 in_vc_files='\.c$$' \
0f00f2c3 605 containing='\<main *(' \
a927b6c1
LC
606 halt='the above files do not call set_program_name' \
607 $(_sc_search_regexp)
c84bdaf6 608
0f00f2c3
LC
609# Ensure that each .c file containing a "main" function also
610# calls bindtextdomain.
611sc_bindtextdomain:
612 @require='bindtextdomain *\(' \
613 in_vc_files='\.c$$' \
614 containing='\<main *(' \
615 halt='the above files do not call bindtextdomain' \
616 $(_sc_search_regexp)
617
c84bdaf6
LC
618# Require that the final line of each test-lib.sh-using test be this one:
619# Exit $fail
620# Note: this test requires GNU grep's --label= option.
621Exit_witness_file ?= tests/test-lib.sh
622Exit_base := $(notdir $(Exit_witness_file))
623sc_require_test_exit_idiom:
624 @if test -f $(srcdir)/$(Exit_witness_file); then \
625 die=0; \
626 for i in $$(grep -l -F 'srcdir/$(Exit_base)' \
627 $$($(VC_LIST) tests)); do \
628 tail -n1 $$i | grep '^Exit .' > /dev/null \
629 && : || { die=1; echo $$i; } \
630 done; \
631 test $$die = 1 && \
632 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
633 echo 1>&2 'Exit something'; \
634 exit 1; } || :; \
635 fi
636
637sc_the_the:
a927b6c1
LC
638 @prohibit='\<the ''the\>' \
639 ignore_case=1 \
640 halt='found use of "the ''the";' \
641 $(_sc_search_regexp)
c84bdaf6
LC
642
643sc_trailing_blank:
a927b6c1
LC
644 @prohibit='[ ]$$' \
645 halt='found trailing blank(s)' \
646 $(_sc_search_regexp)
c84bdaf6
LC
647
648# Match lines like the following, but where there is only one space
649# between the options and the description:
650# -D, --all-repeated[=delimit-method] print all duplicate lines\n
651longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
652sc_two_space_separator_in_usage:
a927b6c1
LC
653 @prohibit='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
654 halt='help2man requires at least two spaces between an option and its description'\
655 $(_sc_search_regexp)
c84bdaf6
LC
656
657# Look for diagnostics that aren't marked for translation.
658# This won't find any for which error's format string is on a separate line.
659sc_unmarked_diagnostics:
660 @grep -nE \
a927b6c1 661 '\<error *\([^"]*"[^"]*[a-z]{3}' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
662 | grep -v '_''(' && \
663 { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \
664 exit 1; } || :
665
666# Avoid useless parentheses like those in this example:
667# #if defined (SYMBOL) || defined (SYM2)
668sc_useless_cpp_parens:
a927b6c1
LC
669 @prohibit='^# *if .*defined *\(' \
670 halt='found useless parentheses in cpp directive' \
671 $(_sc_search_regexp)
672
673# List headers for which HAVE_HEADER_H is always true, assuming you are
674# using the appropriate gnulib module. CAUTION: for each "unnecessary"
675# #if HAVE_HEADER_H that you remove, be sure that your project explicitly
676# requires the gnulib module that guarantees the usability of that header.
677gl_assured_headers_ = \
678 cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
679
680# Convert the list of names to upper case, and replace each space with "|".
681az_ = abcdefghijklmnopqrstuvwxyz
682AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
683gl_header_upper_case_or_ = \
684 $$($(gl_assured_headers_) \
685 | tr $(az_)/.- $(AZ_)___ \
686 | tr -s ' ' '|' \
687 )
688sc_prohibit_always_true_header_tests:
689 @or=$(gl_header_upper_case_or_); \
690 re="HAVE_($$or)_H"; \
691 prohibit='\<'"$$re"'\>' \
0f00f2c3
LC
692 halt=$$(printf '%s\n' \
693 'do not test the above HAVE_<header>_H symbol(s);' \
694 ' with the corresponding gnulib module, they are always true') \
a927b6c1
LC
695 $(_sc_search_regexp)
696
697# ==================================================================
698gl_other_headers_ ?= \
699 intprops.h \
700 openat.h \
701 stat-macros.h
702
703# Perl -lne code to extract "significant" cpp-defined symbols from a
704# gnulib header file, eliminating a few common false-positives.
705gl_extract_significant_defines_ = \
706 /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
707 && $$2 !~ /(?:rpl_|_used_without_)/\
708 && $$1 !~ /^(?:NSIG|ATTRIBUTE_NORETURN)$$/\
709 and print $$1
710
711# Create a list of regular expressions matching the names
712# of macros that are guaranteed to be defined by parts of gnulib.
713define def_sym_regex
714 gen_h=$(gl_generated_headers_); \
715 (cd $(gnulib_dir)/lib; \
716 for f in *.in.h $(gl_other_headers_); do \
717 perl -lne '$(gl_extract_significant_defines_)' $$f; \
718 done; \
719 ) | sort -u \
720 | grep -Ev '^ATTRIBUTE_NORETURN' \
721 | sed 's/^/^ *# *(define|undef) */;s/$$/\\>/'
722endef
723
724# Don't define macros that we already get from gnulib header files.
725sc_prohibit_always-defined_macros:
726 @if test -d $(gnulib_dir); then \
727 case $$(echo all: | grep -l -f - Makefile) in Makefile);; *) \
728 echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
729 esac; \
730 $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT)) \
731 && { echo '$(ME): define the above via some gnulib .h file' \
732 1>&2; exit 1; } || :; \
733 fi
734# ==================================================================
735
736# Prohibit checked in backup files.
737sc_prohibit_backup_files:
738 @$(VC_LIST) | grep '~$$' && \
739 { echo '$(ME): found version controlled backup file' 1>&2; \
740 exit 1; } || :
c84bdaf6
LC
741
742# Require the latest GPL.
743sc_GPL_version:
a927b6c1
LC
744 @prohibit='either ''version [^3]' \
745 halt='GPL vN, N!=3' \
746 $(_sc_search_regexp)
c84bdaf6 747
61cd9dc9
LC
748# Require the latest GFDL. Two regexp, since some .texi files end up
749# line wrapping between 'Free Documentation License,' and 'Version'.
750_GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
751sc_GFDL_version:
a927b6c1
LC
752 @prohibit='$(_GFDL_regexp)' \
753 halt='GFDL vN, N!=3' \
754 $(_sc_search_regexp)
755
0f00f2c3
LC
756# Don't use Texinfo's @acronym{}.
757# http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
a927b6c1
LC
758texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
759sc_texinfo_acronym:
760 @prohibit='@acronym\{' \
761 in_vc_files='$(texinfo_suffix_re_)' \
762 halt='found use of Texinfo @acronym{}' \
763 $(_sc_search_regexp)
61cd9dc9 764
c84bdaf6
LC
765cvs_keywords = \
766 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
767
768sc_prohibit_cvs_keyword:
a927b6c1
LC
769 @prohibit='\$$($(cvs_keywords))\$$' \
770 halt='do not use CVS keyword expansion' \
771 $(_sc_search_regexp)
772
773# This Perl code is slightly obfuscated. Not only is each "$" doubled
774# because it's in a Makefile, but the $$c's are comments; we cannot
775# use "#" due to the way the script ends up concatenated onto one line.
776# It would be much more concise, and would produce better output (including
777# counts) if written as:
778# perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
779# but that would be far less efficient, reading the entire contents
780# of each file, rather than just the last two bytes of each.
dd36ce77
MW
781# In addition, while the code below detects both blank lines and a missing
782# newline at EOF, the above detects only the former.
a927b6c1
LC
783#
784# This is a perl script that is expected to be the single-quoted argument
785# to a command-line "-le". The remaining arguments are file names.
dd36ce77
MW
786# Print the name of each file that ends in exactly one newline byte.
787# I.e., warn if there are blank lines (2 or more newlines), or if the
788# last byte is not a newline. However, currently we don't complain
789# about any file that contains exactly one byte.
a927b6c1
LC
790# Exit nonzero if at least one such file is found, otherwise, exit 0.
791# Warn about, but otherwise ignore open failure. Ignore seek/read failure.
792#
793# Use this if you want to remove trailing empty lines from selected files:
794# perl -pi -0777 -e 's/\n\n+$/\n/' files...
795#
dd36ce77 796require_exactly_one_NL_at_EOF_ = \
a927b6c1
LC
797 foreach my $$f (@ARGV) \
798 { \
799 open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next; \
800 my $$p = sysseek (F, -2, 2); \
801 my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
802 my $$last_two_bytes; \
803 defined $$p and $$p = sysread F, $$last_two_bytes, 2; \
804 close F; \
805 $$c = "ignore read failure"; \
dd36ce77
MW
806 $$p && ($$last_two_bytes eq "\n\n" \
807 || substr ($$last_two_bytes,1) ne "\n") \
808 and (print $$f), $$fail=1; \
a927b6c1
LC
809 } \
810 END { exit defined $$fail }
811sc_prohibit_empty_lines_at_EOF:
dd36ce77
MW
812 @perl -le '$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
813 || { echo '$(ME): empty line(s) or no newline at EOF' \
a927b6c1 814 1>&2; exit 1; } || :; \
c84bdaf6
LC
815
816# Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
817# This is a bit of a kludge, since it prevents use of the string
818# even in comments, but for now it does the job with no false positives.
819sc_prohibit_stat_st_blocks:
a927b6c1
LC
820 @prohibit='[.>]st_blocks' \
821 halt='do not use st_blocks; use ST_NBLOCKS' \
822 $(_sc_search_regexp)
c84bdaf6
LC
823
824# Make sure we don't define any S_IS* macros in src/*.c files.
825# They're already defined via gnulib's sys/stat.h replacement.
826sc_prohibit_S_IS_definition:
a927b6c1
LC
827 @prohibit='^ *# *define *S_IS' \
828 halt='do not define S_IS* macros; include <sys/stat.h>' \
829 $(_sc_search_regexp)
830
831_ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
832_ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
833# Using test's -a and -o operators is not portable.
834# We prefer test over [, since the latter is spelled [[ in configure.ac.
835sc_prohibit_test_minus_ao:
836 @prohibit='(\<test| \[+) .+ -[ao] ' \
837 halt='$(_ptm1); $(_ptm2)' \
838 $(_sc_search_regexp)
c84bdaf6 839
0f00f2c3
LC
840# Avoid a test bashism.
841sc_prohibit_test_double_equal:
842 @prohibit='(\<test| \[+) .+ == ' \
843 containing='#! */bin/[a-z]*sh' \
844 halt='use "test x = x", not "test x =''= x"' \
845 $(_sc_search_regexp)
846
61cd9dc9
LC
847# Each program that uses proper_name_utf8 must link with one of the
848# ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
849# The perl -0777 invocation below extracts the possibly-multi-line
850# definition of LDADD from the appropriate Makefile.am and exits 0
851# when it contains "ICONV".
c84bdaf6
LC
852sc_proper_name_utf8_requires_ICONV:
853 @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
854 if test "x$$progs" != x; then \
855 fail=0; \
856 for p in $$progs; do \
857 dir=$$(dirname "$$p"); \
61cd9dc9
LC
858 perl -0777 \
859 -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
860 $$dir/Makefile.am && continue; \
c84bdaf6
LC
861 base=$$(basename "$$p" .c); \
862 grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
863 || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
864 done; \
865 test $$fail = 1 && \
866 { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
867 exit 1; } || :; \
868 fi
869
870# Warn about "c0nst struct Foo const foo[]",
871# but not about "char const *const foo" or "#define const const".
872sc_redundant_const:
a927b6c1
LC
873 @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
874 halt='redundant "const" in declarations' \
875 $(_sc_search_regexp)
c84bdaf6
LC
876
877sc_const_long_option:
878 @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT)) \
879 | grep -Ev 'const struct option|struct option const' && { \
880 echo 1>&2 '$(ME): add "const" to the above declarations'; \
881 exit 1; } || :
882
883NEWS_hash = \
884 $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
885 $(srcdir)/NEWS \
61cd9dc9
LC
886 | perl -0777 -pe \
887 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
c84bdaf6
LC
888 | md5sum - \
889 | sed 's/ .*//')
890
891# Ensure that we don't accidentally insert an entry into an old NEWS block.
892sc_immutable_NEWS:
893 @if test -f $(srcdir)/NEWS; then \
894 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
895 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
896 fi
897
898# Update the hash stored above. Do this after each release and
899# for any corrections to old entries.
900update-NEWS-hash: NEWS
901 perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
902 $(srcdir)/cfg.mk
903
904# Ensure that we use only the standard $(VAR) notation,
905# not @...@ in Makefile.am, now that we can rely on automake
906# to emit a definition for each substituted variable.
907# We use perl rather than "grep -nE ..." to exempt a single
908# use of an @...@-delimited variable name in src/Makefile.am.
61cd9dc9
LC
909# Allow the package to add exceptions via a hook in cfg.mk;
910# for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
911# setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
912_makefile_at_at_check_exceptions ?=
913sc_makefile_at_at_check:
914 @perl -ne '/\@[A-Z_0-9]+\@/'$(_makefile_at_at_check_exceptions) \
c84bdaf6
LC
915 -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
916 $$($(VC_LIST_EXCEPT) | grep -E '(^|/)Makefile\.am$$') \
917 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
918
1cd4fffc 919news-check: NEWS
9157d901
LC
920 if sed -n $(news-check-lines-spec)p $(srcdir)/NEWS \
921 | grep -E $(news-check-regexp) >/dev/null; then \
c84bdaf6
LC
922 :; \
923 else \
1cd4fffc 924 echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
c84bdaf6
LC
925 exit 1; \
926 fi
927
928sc_makefile_TAB_only_indentation:
a927b6c1
LC
929 @prohibit='^ [ ]{8}' \
930 in_vc_files='akefile|\.mk$$' \
931 halt='found TAB-8-space indentation' \
932 $(_sc_search_regexp)
c84bdaf6
LC
933
934sc_m4_quote_check:
a927b6c1
LC
935 @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
936 in_vc_files='(^configure\.ac|\.m4)$$' \
937 halt='quote the first arg to AC_DEF*' \
938 $(_sc_search_regexp)
c84bdaf6
LC
939
940fix_po_file_diag = \
941'you have changed the set of files with translatable diagnostics;\n\
942apply the above patch\n'
943
944# Verify that all source files using _() are listed in po/POTFILES.in.
945po_file = po/POTFILES.in
946sc_po_check:
947 @if test -f $(po_file); then \
948 grep -E -v '^(#|$$)' $(po_file) \
949 | grep -v '^src/false\.c$$' | sort > $@-1; \
950 files=; \
951 for file in $$($(VC_LIST_EXCEPT)) lib/*.[ch]; do \
952 test -r $$file || continue; \
953 case $$file in \
954 *.m4|*.mk) continue ;; \
955 *.?|*.??) ;; \
956 *) continue;; \
957 esac; \
958 case $$file in \
959 *.[ch]) \
960 base=`expr " $$file" : ' \(.*\)\..'`; \
961 { test -f $$base.l || test -f $$base.y; } && continue;; \
962 esac; \
963 files="$$files $$file"; \
964 done; \
965 grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
966 | sort -u > $@-2; \
967 diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
968 || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
969 rm -f $@-1 $@-2; \
970 fi
971
972# Sometimes it is useful to change the PATH environment variable
973# in Makefiles. When doing so, it's better not to use the Unix-centric
974# path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
975msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
976sc_makefile_path_separator_check:
a927b6c1
LC
977 @prohibit='PATH[=].*:' \
978 in_vc_files='akefile|\.mk$$' \
979 halt=$(msg) \
980 $(_sc_search_regexp)
c84bdaf6
LC
981
982# Check that `make alpha' will not fail at the end of the process.
983writable-files:
984 if test -d $(release_archive_dir); then :; else \
985 for file in $(distdir).tar.gz \
986 $(release_archive_dir)/$(distdir).tar.gz; do \
987 test -e $$file || continue; \
988 test -w $$file \
989 || { echo ERROR: $$file is not writable; fail=1; }; \
990 done; \
991 test "$$fail" && exit 1 || : ; \
992 fi
993
2e65b52f 994v_etc_file = $(gnulib_dir)/lib/version-etc.c
c84bdaf6
LC
995sample-test = tests/sample-test
996texi = doc/$(PACKAGE).texi
997# Make sure that the copyright date in $(v_etc_file) is up to date.
998# Do the same for the $(sample-test) and the main doc/.texi file.
999sc_copyright_check:
a927b6c1
LC
1000 @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' \
1001 in_files=$(v_etc_file) \
1002 halt='out of date copyright in $(v_etc_file); update it' \
1003 $(_sc_search_regexp)
1004 @require='# Copyright \(C\) '$$(date +%Y)' Free' \
1005 in_vc_files=$(sample-test) \
1006 halt='out of date copyright in $(sample-test); update it' \
1007 $(_sc_search_regexp)
1008 @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free' \
1009 in_vc_files=$(texi) \
1010 halt='out of date copyright in $(texi); update it' \
1011 $(_sc_search_regexp)
1012
1013# If tests/help-version exists and seems to be new enough, assume that its
1014# use of init.sh and path_prepend_ is correct, and ensure that every other
1015# use of init.sh is identical.
1016# This is useful because help-version cross-checks prog --version
1017# with $(VERSION), which verifies that its path_prepend_ invocation
1018# sets PATH correctly. This is an inexpensive way to ensure that
1019# the other init.sh-using tests also get it right.
1020_hv_file ?= $(srcdir)/tests/help-version
1021_hv_regex_weak ?= ^ *\. .*/init\.sh"
1022_hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1023sc_cross_check_PATH_usage_in_tests:
1024 @if test -f $(_hv_file); then \
1025 grep -l 'VERSION mismatch' $(_hv_file) >/dev/null \
1026 || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2; \
1027 exit 0; }; \
1028 grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null \
1029 || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1030 exit 1; }; \
1031 good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file)); \
1032 grep -LFx "$$good" \
1033 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT))) \
1034 | grep . && \
1035 { echo "$(ME): the above files use path_prepend_ inconsistently" \
1036 1>&2; exit 1; } || :; \
c84bdaf6
LC
1037 fi
1038
61cd9dc9
LC
1039# #if HAVE_... will evaluate to false for any non numeric string.
1040# That would be flagged by using -Wundef, however gnulib currently
1041# tests many undefined macros, and so we can't enable that option.
1042# So at least preclude common boolean strings as macro values.
1043sc_Wundef_boolean:
a927b6c1
LC
1044 @prohibit='^#define.*(yes|no|true|false)$$' \
1045 in_files='$(CONFIG_INCLUDE)' \
1046 halt='Use 0 or 1 for macro values' \
1047 $(_sc_search_regexp)
61cd9dc9
LC
1048
1049sc_vulnerable_makefile_CVE-2009-4029:
a927b6c1
LC
1050 @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1051 in_files=$$(find $(srcdir) -name Makefile.in) \
0f00f2c3
LC
1052 halt=$$(printf '%s\n' \
1053 'the above files are vulnerable; beware of running' \
1054 ' "make dist*" rules, and upgrade to fixed automake' \
1055 ' see http://bugzilla.redhat.com/542609 for details') \
a927b6c1 1056 $(_sc_search_regexp)
61cd9dc9 1057
c84bdaf6
LC
1058vc-diff-check:
1059 (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1060 if test -s vc-diffs; then \
1061 cat vc-diffs; \
1062 echo "Some files are locally modified:" 1>&2; \
1063 exit 1; \
1064 else \
1065 rm vc-diffs; \
1066 fi
1067
c84bdaf6
LC
1068rel-files = $(DIST_ARCHIVES)
1069
1070gnulib_dir ?= $(srcdir)/gnulib
1071gnulib-version = $$(cd $(gnulib_dir) && git describe)
1072bootstrap-tools ?= autoconf,automake,gnulib
1073
61cd9dc9
LC
1074# If it's not already specified, derive the GPG key ID from
1075# the signed tag we've just applied to mark this release.
1076gpg_key_ID ?= \
1077 $$(git cat-file tag v$(VERSION) > .ann-sig \
1078 && gpgv .ann-sig - < /dev/null 2>&1 \
1079 | sed -n '/.*key ID \([0-9A-F]*\)/s//\1/p'; rm -f .ann-sig)
1080
a927b6c1
LC
1081translation_project_ ?= coordinator@translationproject.org
1082announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1083announcement_mail_headers_ ?= \
1084To: info-gnu@gnu.org \
1085Cc: $(announcement_Cc_) \
1086Mail-Followup-To: $(PACKAGE_BUGREPORT)
1087
c84bdaf6
LC
1088announcement: NEWS ChangeLog $(rel-files)
1089 @$(build_aux)/announce-gen \
a927b6c1 1090 --mail-headers='$(announcement_mail_headers_)' \
c84bdaf6
LC
1091 --release-type=$(RELEASE_TYPE) \
1092 --package=$(PACKAGE) \
1093 --prev=$(PREV_VERSION) \
1094 --curr=$(VERSION) \
1095 --gpg-key-id=$(gpg_key_ID) \
61cd9dc9 1096 --news=$(srcdir)/NEWS \
c84bdaf6
LC
1097 --bootstrap-tools=$(bootstrap-tools) \
1098 --gnulib-version=$(gnulib-version) \
1099 --no-print-checksums \
1100 $(addprefix --url-dir=, $(url_dir_list))
1101
1102## ---------------- ##
1103## Updating files. ##
1104## ---------------- ##
1105
1106ftp-gnu = ftp://ftp.gnu.org/gnu
1107www-gnu = http://www.gnu.org
1108
dde9c5a4 1109upload_dest_dir_ ?= $(PACKAGE)
c84bdaf6
LC
1110emit_upload_commands:
1111 @echo =====================================
1112 @echo =====================================
1113 @echo "$(build_aux)/gnupload $(GNUPLOADFLAGS) \\"
dde9c5a4 1114 @echo " --to $(gnu_rel_host):$(upload_dest_dir_) \\"
c84bdaf6 1115 @echo " $(rel-files)"
61cd9dc9 1116 @echo '# send the ~/announce-$(my_distdir) e-mail'
c84bdaf6
LC
1117 @echo =====================================
1118 @echo =====================================
1119
c84bdaf6
LC
1120define emit-commit-log
1121 printf '%s\n' 'post-release administrivia' '' \
1122 '* NEWS: Add header line for next release.' \
1123 '* .prev-version: Record previous version.' \
1124 '* cfg.mk (old_NEWS_hash): Auto-update.'
1125endef
1126
1127.PHONY: no-submodule-changes
1128no-submodule-changes:
1129 if test -d $(srcdir)/.git; then \
1130 diff=$$(cd $(srcdir) && git submodule -q foreach \
1131 git diff-index --name-only HEAD) \
1132 || exit 1; \
1133 case $$diff in '') ;; \
1134 *) echo '$(ME): submodule files are locally modified:'; \
1135 echo "$$diff"; exit 1;; esac; \
1136 else \
1137 : ; \
1138 fi
1139
49114fd4
LC
1140submodule-checks ?= no-submodule-changes public-submodule-commit
1141
1142# Ensure that each sub-module commit we're using is public.
1143# Without this, it is too easy to tag and release code that
1144# cannot be built from a fresh clone.
1145.PHONY: public-submodule-commit
1146public-submodule-commit:
1147 $(AM_V_GEN)if test -d $(srcdir)/.git; then \
1148 cd $(srcdir) && \
1149 git submodule --quiet foreach test '$$(git rev-parse $$sha1)' \
1150 = '$$(git merge-base origin $$sha1)' \
1151 || { echo '$(ME): found non-public submodule commit' >&2; \
1152 exit 1; }; \
1153 else \
1154 : ; \
1155 fi
1156# This rule has a high enough utility/cost ratio that it should be a
1157# dependent of "check" by default. However, some of us do occasionally
1158# commit a temporary change that deliberately points to a non-public
1159# submodule commit, and want to be able to use rules like "make check".
1160# In that case, run e.g., "make check gl_public_submodule_commit="
1161# to disable this test.
1162gl_public_submodule_commit ?= public-submodule-commit
1163check: $(gl_public_submodule_commit)
1164
c84bdaf6
LC
1165.PHONY: alpha beta stable
1166ALL_RECURSIVE_TARGETS += alpha beta stable
49114fd4 1167alpha beta stable: $(local-check) writable-files $(submodule-checks)
c84bdaf6
LC
1168 test $@ = stable \
1169 && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
1170 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1171 || :
1172 $(MAKE) vc-diff-check
1cd4fffc 1173 $(MAKE) news-check
c84bdaf6
LC
1174 $(MAKE) distcheck
1175 $(MAKE) dist XZ_OPT=-9ev
1cd4fffc
LC
1176 $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1177 $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1178
1179# Override this in cfg.mk if you follow different procedures.
1180release-prep-hook ?= release-prep
1181
0f00f2c3 1182gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1cd4fffc
LC
1183.PHONY: release-prep
1184release-prep:
1185 case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1186 *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
61cd9dc9 1187 $(MAKE) -s announcement > ~/announce-$(my_distdir)
c84bdaf6
LC
1188 if test -d $(release_archive_dir); then \
1189 ln $(rel-files) $(release_archive_dir); \
1190 chmod a-w $(rel-files); \
1191 fi
c84bdaf6
LC
1192 echo $(VERSION) > $(prev_version_file)
1193 $(MAKE) update-NEWS-hash
0f00f2c3 1194 perl -pi -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' NEWS
c84bdaf6
LC
1195 $(emit-commit-log) > .ci-msg
1196 $(VC) commit -F .ci-msg -a
61cd9dc9 1197 rm .ci-msg
c84bdaf6 1198
a927b6c1
LC
1199# Override this with e.g., -s $(srcdir)/some_other_name.texi
1200# if the default $(PACKAGE)-derived name doesn't apply.
1201gendocs_options_ ?=
1202
c84bdaf6
LC
1203.PHONY: web-manual
1204web-manual:
1205 @test -z "$(manual_title)" \
1206 && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1207 @cd '$(srcdir)/doc'; \
a927b6c1
LC
1208 $(SHELL) ../build-aux/gendocs.sh $(gendocs_options_) \
1209 -o '$(abs_builddir)/doc/manual' \
c84bdaf6
LC
1210 --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1211 "$(PACKAGE_NAME) - $(manual_title)"
1212 @echo " *** Upload the doc/manual directory to web-cvs."
1213
1214# Code Coverage
1215
1216init-coverage:
1217 $(MAKE) $(AM_MAKEFLAGS) clean
1218 lcov --directory . --zerocounters
1219
1220COVERAGE_CCOPTS ?= "-g --coverage"
1221COVERAGE_OUT ?= doc/coverage
1222
1223build-coverage:
1224 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1225 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1226 mkdir -p $(COVERAGE_OUT)
1227 lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1228 --capture
1229
1230gen-coverage:
1231 genhtml --output-directory $(COVERAGE_OUT) \
1232 $(COVERAGE_OUT)/$(PACKAGE).info \
1233 --highlight --frames --legend \
1234 --title "$(PACKAGE_NAME)"
1235
1236coverage: init-coverage build-coverage gen-coverage
1237
1238# Update gettext files.
1239PACKAGE ?= $(shell basename $(PWD))
1240PO_DOMAIN ?= $(PACKAGE)
1241POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1242PODIR ?= po
1243refresh-po:
1244 rm -f $(PODIR)/*.po && \
1245 echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1246 wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1247 echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1248 echo 'en@quot' >> $(PODIR)/LINGUAS && \
1249 ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
1250
a927b6c1 1251 # Running indent once is not idempotent, but running it twice is.
c84bdaf6
LC
1252INDENT_SOURCES ?= $(C_SOURCES)
1253.PHONY: indent
1254indent:
1255 indent $(INDENT_SOURCES)
a927b6c1 1256 indent $(INDENT_SOURCES)
c84bdaf6
LC
1257
1258# If you want to set UPDATE_COPYRIGHT_* environment variables,
1259# put the assignments in this variable.
1260update-copyright-env ?=
1261
1262# Run this rule once per year (usually early in January)
1263# to update all FSF copyright year lists in your project.
1264# If you have an additional project-specific rule,
1265# add it in cfg.mk along with a line 'update-copyright: prereq'.
1266# By default, exclude all variants of COPYING; you can also
1267# add exemptions (such as ChangeLog..* for rotated change logs)
1268# in the file .x-update-copyright.
1269.PHONY: update-copyright
1270update-copyright:
1271 grep -l -w Copyright \
1272 $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1273 | $(update-copyright-env) xargs $(build_aux)/$@